/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2011, Tomasz Sowa
 * All rights reserved.
 * 
 */
 

#include "core/log.h"
#include "core/plugin.h"
#include "exportthread.h"


extern "C" void Init(PluginInfo &);




namespace Export
{


const wchar_t plugin_name[] = L"export";
int mount_par_export_conf = -1;
ExportThread export_thread;







void AddMountParams(PluginInfo & info)
{
using TemplatesFunctions::system;

	mount_par_export_conf = system->mounts.AddMountPar(L"export_conf");
}



void FstabChanged(PluginInfo & info)
{
}


void SendFile(PluginInfo & info)
{
	Item & item = *reinterpret_cast<Item*>(info.p1);

	log << log1 << "bedziemy wysylac strone o tytule: " << item.subject << ", url: " << item.url << logend;
}



void AddEzcFunctions(PluginInfo & info);

} // namespace





void Init(PluginInfo & info)
{
using namespace Export;

//	plugin.Assign(WINIX_TEMPLATES_CREATEFUNCTIONS,		AddEzcFunctions);
	plugin.Assign(WINIX_ADD_MOUNTS,						AddMountParams);
//	plugin.Assign(WINIX_FSTAB_CHANGED,					FstabChanged);


	plugin.Assign(WINIX_FILE_ADDED,						SendFile);
	plugin.Assign(WINIX_FILE_CHANGED,					SendFile);

	info.p1 = (void*)(plugin_name);
}


